<template>
    <div class="container">
        <div class="margin-top-50"></div>
        <div class="row">
            <div class="columns twelve block-credit-rating">
                <div class="content">
                    <h3 class="main-header">Кредитный рейтинг</h3>
                    <div class="steps">
                        <div class="step pass">
                            <span>1</span>
                            <div>Заполнение анкеты</div>
                        </div>
                        <div class="step">
                            <span>2</span>
                            <div>Оплата</div>
                        </div>
                        <div class="step">
                            <span>3</span>
                            <div>Кредитный рейтинг</div>
                        </div>
                    </div>
                    <div v-if="isClientValidationError" class="warning-block white-block">
                        Убедитесь в правильности заполнения полей! Указав недостоверные данные о себе, Вы рискуете получить отчет, не соответствующий действительности!
                    </div>
                    <div ref="serverValidationError" v-if="isServerValidationError" class="error-block white-block">
                        Введённые данные не валидны. Проверьте правильность заполнения.
                    </div>
                    <div class="white-block">

                        <div class="padding">
                            <h3>Личные данные</h3>
                        </div>
                        <hr/>
                        <div class="padding">
                            <div class="row">
                                <div class="columns four">
                                    <label for="lastName">Фамилия</label>
                                    <input
                                            type="text"
                                            name="lastName"
                                            v-model="formWithUserDataFields.lastName"
                                            ref="lastName"
                                            id="lastName"
                                            v-validate="'cyrillic|required|min:2|max:50'"
                                            :class="getValidateClass('lastName')"
                                            autocomplete="off"
                                            data-code="lastNameTooShort, lastNameTooLong, lastNameInvalidFormat"
                                    />
                                    <validate-message v-show="vErrors.has('lastName')">
                                        {{ vErrors.first('lastName') }}
                                    </validate-message>
                                </div>
                                <div class="columns four">
                                    <label for="firstName">Имя</label>
                                    <input
                                            type="text"
                                            name="firstName"
                                            id="firstName"
                                            ref="firstName"
                                            v-validate="'cyrillic|required|min:2|max:50'"
                                            v-model="formWithUserDataFields.firstName"
                                            :class="getValidateClass('firstName')"
                                            autocomplete="off"
                                            data-code="firstNameTooShort, firstNameTooLong, firstNameInvalidFormat"
                                    />
                                    <validate-message v-show="vErrors.has('firstName')">
                                        {{ vErrors.first('firstName') }}
                                    </validate-message>
                                </div>
                                <div class="columns four">
                                    <label for="middleName">Отчество</label>
                                    <input
                                            type="text"
                                            name="middleName"
                                            id="middleName"
                                            ref="middleName"
                                            v-validate="'required|cyrillic|min:2|max:50'"
                                            v-model="formWithUserDataFields.middleName"
                                            :class="getValidateClass('middleName')"
                                            autocomplete="off"
                                            data-code="middleNameTooShort, middleNameTooLong, middleNameInvalidFormat"
                                    />
                                    <validate-message v-show="vErrors.has('middleName')">
                                        {{ vErrors.first('middleName') }}
                                    </validate-message>
                                </div>
                            </div>
                            <div class="row">
                                <div class="columns four">
                                    <label for="bDay">Дата рождения</label>
                                    <input
                                            type="tel"
                                            name="дата рождения"
                                            id="bDay"
                                            ref="bDay"
                                            v-validate="'required|date_format_check|date_between_bd'"
                                            :class="getValidateClass('дата рождения')"
                                            v-model="formWithUserDataFields.bDay"
                                            v-mask="'##.##.####'"
                                            :guide="true"
                                            placeholder="ДД.ММ.ГГГГ"
                                            :keepCharPositions="true"
                                            autocomplete="off"
                                            data-code="bDayInvalidDateFormat"
                                    >
                                    <validate-message v-show="vErrors.has('дата рождения')">
                                        {{ vErrors.first('дата рождения') }}
                                    </validate-message>
                                </div>
                                <div class="columns four checkbox">
                                    <div class="label-profile">Пол</div>
                                    <input type="radio"
                                           name="gender"
                                           value="male"
                                           id="male"
                                           v-model="formWithUserDataFields.gender"
                                           v-validate="'required'"
                                           data-code="genderNotInAvailableRange"
                                    />
                                    <label for="male"><span></span>Мужской</label>
                                    <input type="radio"
                                           name="gender"
                                           value="female"
                                           id="female"
                                           v-model="formWithUserDataFields.gender"
                                           v-validate="'required'"
                                           :class="getValidateClass('female')"
                                           data-code="genderNotInAvailableRange"
                                    />
                                    <label for="female"><span></span>Женский</label>
                                    <div class="checkbox-gender">
                                        <validate-message v-show="vErrors.has('gender')">
                                            {{ vErrors.first('gender') }}
                                        </validate-message>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="white-block">
                        <div class="padding">
                            <h3>Паспортные данные</h3>
                        </div>
                        <hr/>
                        <div class="padding">
                            <div class="row">
                                <div class="columns four">
                                    <label for="passport">Серия и номер</label>
                                    <input type="tel"
                                           name="passport"
                                           id="passport"
                                           v-validate="'required|serialAndNumber'"
                                           :class="getValidateClass('passport')"
                                           v-model="formWithUserDataFields.passport"
                                           v-mask="'#### ######'"
                                           ref="passport"
                                           :guide="true"
                                           placeholder="1234 567890"
                                           :keepCharPositions="true"
                                           autocomplete="off"
                                           data-code="passportInvalidFormat, passportTooShort, passportTooLong, userPassportDataNotUnique"
                                    >
                                    <validate-message v-show="vErrors.has('passport')">
                                        {{ vErrors.first('passport') }}
                                    </validate-message>
                                </div>
                                <div class="columns four">
                                    <label for="passportDivisionCode">Код подразделения</label>
                                    <input type="tel"
                                           name="passportDivisionCode"
                                           id="passportDivisionCode"
                                           v-validate="'required|passportCode'"
                                           :class="getValidateClass('passportDivisionCode')"
                                           v-model="formWithUserDataFields.passportDivisionCode"
                                           v-mask="'###-###'"
                                           :guide="true"
                                           placeholder="123-456"
                                           :keepCharPositions="true"
                                           @keyup="getWhoIssued()"
                                           autocomplete="off"
                                           data-code="passportDivisionCodeInvalidFormat, passportDivisionCodeTooShort, passportDivisionCodeTooLong"
                                    >
                                    <validate-message v-show="vErrors.has('passportDivisionCode')">
                                        {{ vErrors.first('passportDivisionCode') }}
                                    </validate-message>
                                </div>
                                <div class="columns four">
                                    <label for="passportDateOfIssue">Дата выдачи</label>
                                    <input type="tel"
                                           name="дата выдачи"
                                           id="passportDateOfIssue"
                                           v-validate="'required|date_format_check|date_between_passport|date_passport_validate'"
                                           :class="getValidateClass('дата выдачи')"
                                           v-model="formWithUserDataFields.passportDateOfIssue"
                                           v-mask="'##.##.####'"
                                           :guide="true"
                                           ref="bar"
                                           :keepCharPositions="true"
                                           placeholder="ДД.ММ.ГГГГ"
                                           autocomplete="off"
                                           data-code="passportDateOfIssueLowerThenMin, passportDateOfIssueGreaterThenMax, passportDateOfIssueInvalidDateFormat, passportDateOfIssueLowerThenBirthDate"
                                    >
                                    <validate-message v-show="vErrors.has('дата выдачи')">
                                        {{ vErrors.first('дата выдачи') }}
                                    </validate-message>
                                </div>
                            </div>
                            <div class="row">
                                <div class="column">
                                    <label for="passportIssuedBy">Кем выдан</label>
                                    <input type="text"
                                           name="passportIssuedBy"
                                           id="passportIssuedBy"
                                           v-validate="'required|exceptLatinAndServiceChar|min:6|max:190'"
                                           :class="getValidateClass('passportIssuedBy')"
                                           v-model="formWithUserDataFields.passportIssuedBy"
                                           :guide="true"
                                           placeholder="Выдан отделением ..."
                                           @change="setValue('passportIssuedBy')"
                                           :keepCharPositions="true"
                                           ref="issued"
                                           autocomplete="off"
                                           data-code="passportIssuedByInvalidFormat, passportIssuedByTooShort, passportIssuedByTooLong"
                                    >
                                    <validate-message v-show="vErrors.has('passportIssuedBy')">
                                        {{ vErrors.first('passportIssuedBy') }}
                                    </validate-message>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="white-block">
                        <div class="padding">
                            <h3>Дополнителная информация</h3>
                        </div>
                        <hr/>
                        <div class="padding">
                            <div class="row">
                                <div class="columns four">
                                    <label for="typeOfEmployment">Вид занятости</label>
                                    <multiselect v-model="formWithUserDataFields.typeOfEmployment"
                                                 :options="typeOfEmploymentStatus"
                                                 :value="typeOfEmploymentValue"
                                                 :searchable="false"
                                                 :close-on-select="true"
                                                 :show-labels="false"
                                                 placeholder=""
                                                 id="typeOfEmployment"
                                                 :preserve-search="true"
                                                 label="title"
                                                 track-by="id"
                                                 :vValidateRules = "'required'"
                                                 v-validate="'required'"
                                                 name="typeOfEmployment"
                                                 :class="getValidateClass('typeOfEmployment')"
                                                 data-code="typeOfEmploymentInvalidFormat, typeOfEmploymentNotInAvailableRange"
                                    >
                                    </multiselect>
                                    <validate-message v-show="vErrors.has('typeOfEmployment')">
                                        {{ vErrors.first('typeOfEmployment') }}
                                    </validate-message>
                                </div>
                                <div v-if="formWithUserDataFields.typeOfEmployment.id == 1" class="columns four">
                                    <label for="workType">Тип организации</label>
                                    <multiselect id="workType"
                                                 name="workType"
                                                 v-model="formWithUserDataFields.workType"
                                                 :options="fieldWorkType"
                                                 :value="workTypeValue"
                                                 :vValidateRules="'required'"
                                                 :searchable="false"
                                                 :close-on-select="true"
                                                 :show-labels="false"
                                                 placeholder=""
                                                 :preserve-search="true"
                                                 label="title"
                                                 track-by="id"
                                                 v-validate="'required'"
                                                 :class="getValidateClass('workType')"
                                                 data-code="workTypeInvalidFormat, workTypeNotInAvailableRange"
                                    >
                                    </multiselect>
                                    <validate-message v-show="vErrors.has('workType')">
                                        {{ vErrors.first('workType') }}
                                    </validate-message>
                                </div>
                                <div class="columns four">
                                    <label for="workSalary">Ежемесячный доход</label>
                                    <input type="number"
                                           name="workSalary"
                                           id="workSalary"
                                           maxlength="7"
                                           :class="getValidateClass('workSalary')"
                                           v-model="formWithUserDataFields.workSalary"
                                           v-validate="'required|min_value:2000|max_value:1000000'"
                                           v-mask="'#######'"
                                           autocomplete="off"
                                           data-code="workSalaryInvalidFormat, workSalaryNotInAvailableRange"
                                    />
                                    <validate-message v-show="vErrors.has('workSalary')">
                                        {{ vErrors.first('workSalary') }}
                                    </validate-message>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="white-block">
                        <div class="padding">
                            <h3>Дополнителная информация</h3>
                        </div>
                        <hr/>
                        <div class="padding">
                            <div class="row">
                                <div class="columns four">
                                    <label for="educationType">Образование</label>
                                    <multiselect v-model="formWithUserDataFields.educationType"
                                                 :options="educationStatus"
                                                 :value="educationTypeValue"
                                                 name="educationType"
                                                 :searchable="false"
                                                 :close-on-select="true"
                                                 :show-labels="false"
                                                 placeholder=""
                                                 id="educationType"
                                                 :preserve-search="true"
                                                 label="title"
                                                 track-by="id"
                                                 :vValidateRules="'required'"
                                                 v-validate="'required'"
                                                 :class="getValidateClass('educationType')"
                                                 data-code="educationTypeInvalidFormat, educationTypeNotInAvailableRange"
                                    >
                                    </multiselect>
                                    <validate-message v-show="vErrors.has('educationType')">
                                        {{ vErrors.first('educationType') }}
                                    </validate-message>
                                </div>
                                <div class="columns four">
                                    <label for="sourceOfInformation">Откуда Вы о нас узнали?</label>
                                    <multiselect v-model="formWithUserDataFields.sourceOfInformation"
                                                 :options="sourceOfInformationStatus"
                                                 :value="sourceOfInformationValue"
                                                 :searchable="false"
                                                 :close-on-select="true"
                                                 :show-labels="false"
                                                 placeholder=""
                                                 id="sourceOfInformation"
                                                 :preserve-search="true"
                                                 label="title"
                                                 track-by="id"
                                                 :vValidateRules = "'required'"
                                                 name="sourceOfInformation"
                                                 v-validate="'required'"
                                                 :class="getValidateClass('sourceOfInformation')"
                                                 data-code="sourceOfInformationInvalidFormat, sourceOfInformationNotInAvailableRange"
                                    >
                                    </multiselect>

                                    <validate-message v-show="vErrors.has('sourceOfInformation')">
                                        {{ vErrors.first('sourceOfInformation') }}
                                    </validate-message>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="warning-block white-block">
                        В данный момент доступна оплата только банковской картой.
                    </div>
                    <div class="white-block">
                        <div class="checkbox padding">
                            <input type="checkbox"
                                   name="processing-agree"
                                   id="processing-agree"
                                   v-model="formWithUserDataFields.compliance"
                                   v-validate="'required'"
                            >
                            <label for="processing-agree" ref="agreeLabel" :class="{red: notAgree}">
                                <span></span>
                                Я даю согласие на <a @click.prevent="$modal.show('consent')" href="#">обработку и хранение</a> моих персональных данных, я согласен на запрос
                                и передачу моих персональных данных в бюро кредитных историй.
                            </label>
                        </div>
                    </div>
                    <div class="button-centrated">
                        <button class="marg-b-50" @click="goToNextStep" :disabled="!formWithUserDataFields.compliance">Перейти к оплате</button>
                    </div>
                </div>
            </div>
        </div>
		<consent-to-the-processing-of-personal-data></consent-to-the-processing-of-personal-data>
    </div>
</template>

<script>
    import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
    import UserErrorText from '@/mixins/User/UserErrorTextMixin'
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
	import creditRatingErrors from '@/utils/error_mapper/creditRating'
	import ConsentToTheProcessingOfPersonalData from '@/pages/Registration/FirstPage/ConsentToTheProcessingOfPersonalData'

    import validateForm from './methods/validateForm';
	import setExistingValues from './methods/setExistingValues';
	import goToNextStep from './methods/goToNextStep';
	import createCreditRatingProcessGetData from './methods/createCreditRatingProcessGetData';
    import getPaymentCreditRatingData from './methods/getPaymentCreditRatingData';

    export default {
        name: 'FillingTheForm',

        mixins: [
            ErrorHandleMixin,
            UserErrorText,
            GetValidateClass,
        ],

		components: {
			ConsentToTheProcessingOfPersonalData,
		},

        props: {
            formWithUserDataFields: {
                type: Object,
                required: true,
            },
        },

        data() {
            return {
                form: {
                    lastName: '',
					firstName: '',
                    middleName: '',
					/*birthday*/
                    bDay: '',
                    /*isMenGender*/
                    gender: 'male',
                    /*passportSerialAndNumber*/
                    passport: '',
                    passportDivisionCode: '',
					passportDateOfIssue: '',
					passportIssuedBy: '',
					typeOfEmployment: '',
                    /*organizationType*/
					workType: '',
                    /*monthlyIncome*/
					workSalary: 0,
                    /*education*/
					educationType: '',
                    /*howDidYouHearAboutUs*/
					sourceOfInformation: '',
					compliance: false,
                },
				notAgree: false,
				typeOfEmploymentStatus: [
					{id: 1, title: 'Наемный сотрудник'},
					{id: 2, title: 'Индивидуальный предприниматель'},
					{id: 3, title: 'Учредитель/участник ООО'},
					{id: 4, title: 'Пенсионер'},
					{id: 5, title: 'Студент'},
					{id: 6, title: 'Безработный'},
					{id: 7, title: 'Работаю на себя'},
					{id: 8, title: 'Военнослужащий'}
				],
				fieldWorkType: [
					{id: 1, title: 'Государственная'},
					{id: 2, title: 'Частная'}
				],
				educationStatus: [
					{id: 1, title: 'Среднее/среднее специальное'},
					{id: 2, title: 'Неполное высшее'},
					{id: 3, title: 'Высшее образование'},
					{id: 4, title: 'Ученая степень'}
				],
				sourceOfInformationStatus: [
					{id: 1, title: 'Социальные сети'},
					{id: 2, title: 'Рассылка на электронную почту'},
					{id: 3, title: 'Поисковые системы (яндекс, google и т.п.)'},
					{id: 4, title: 'Реклама на ТВ'},
					{id: 5, title: 'Рекомендации друзей, знакомых'},
					{id: 6, title: 'Реклама на радио'},
					{id: 7, title: 'Другое'}
				],
                isClientValidationError: false,
				isServerValidationError: false,
            }
        },

        computed: {
			storeCreditRatingState() {
				return this.$store.state.creditRating;
			},
            typeOfEmploymentValue() {
				return this.formWithUserDataFields.typeOfEmployment = this.typeOfEmploymentStatus[this.$user.typeOfEmployment - 1];

            },
            workTypeValue() {
                if(!this.$user.workType) {
					this.$user.workType = 1;
                }
                return this.fieldWorkType[this.$user.workType - 1];
            },
            educationTypeValue() {
                return this.formWithUserDataFields.educationType = this.educationStatus[this.$user.educationType - 1];
            },
            sourceOfInformationValue() {
                return this.formWithUserDataFields.sourceOfInformation = this.sourceOfInformationStatus[this.$user.sourceOfInformation - 1];
            },
			userLocationData() {
				return this.$store.state.user.address;
			},
        },

        methods: {
			setExistingValues,
            validateForm,
			createCreditRatingProcessGetData,
            getPaymentCreditRatingData,
			goToNextStep,
        },

        created() {
        	/*если пользователь авторизован*/
            if (this.$auth.isAuth) {
                this.setExistingValues();
            }
        },
    }
</script>
